Multi-categorical Connected Component Labelling (CCL) algorithm identifies all 4- or
8- connected regions of cells sharing the same categorical values and assigns 
each of them a unique label. 

The plClump4p, a multi-categorical CCL algorithm,
is an efficient variant of a two-scan algorithm modified for use in multi-categorical rasters.
It applies a divide-and-conquer technique coupled with parallel processing to
a standard two-scan algorithm. Using these techniques causes that algorithm's performance 
is two-three orders of magnitude better than standard CCL algorithms. The specific speed up
depends on the size of the data and its complexity and is greatest for very large and 
complex rasters.

Windows and linux binaries are included in [plTools](http://gitlist.netzel.pl/plTools) package.

The program is available under GPL v3 license.

The implemented algotithm is described in the following paper:
[Pawel Netzel, Tomasz F. Stepinski, 2013: *Connected components labeling for giga-cell 
multi-categorical rasters*, Computers & Geosciences, Volume 59, pp 24-30,
DOI: 10.1016/j.cageo.2013.05.014](https://www.sciencedirect.com/science/article/pii/S0098300413001611).
